//==============================================================================
//
//      Caixinha musical - PInC Panther
//
//
//      Autor: Cludio Lrios      26/07/2014
//
//      Utiliza pic 12f675
//
//      Reproduz som da trilha sonora do desenho animado 'Pantera cor-de-rosa'
//      (adaptao primitiva da msica, para fins didticos)
//      Parte integrante do blog 'Larios.Tecnologia.WS'
//==============================================================================
//  Conexo ao PIC:
//  Ligue +3 volts no pino 1, gnd no pino 8 e um piezoeletrico no pino 2 ao gnd
//  Poder usar 2 pilhas de 1,5 volts AA ou pilha boto LR932 ou similar.
//==============================================================================
#include <12F675.h>
#device adc=8
#use delay(clock=4000000)
#fuses NOWDT,INTRC_IO, NOCPD, NOPROTECT, NOMCLR, NOPUT, NOBROWNOUT

#define TONE_PIN  PIN_A5//saida de som no  pino 2
#bit   t1if     =0x0c.0 //flag do timer 1


//TABELA COM FREQUENCIAS DAS NOTAS USADAS
const int16 nota_do  =262;
const int16 nota_reb  =277;
const int16 nota_re  =293;
const int16 nota_mib  =311;
const int16 nota_mi  =329;
const int16 nota_fa  =349;
const int16 nota_solb  =370;
const int16 nota_sol  =392;
const int16 nota_lab  =415;
const int16 nota_la  =440;
const int16 nota_sib  =466;
const int16 nota_si  =493;

const int16 nota_xdo  =524;
const int16 nota_xreb  =554;
const int16 nota_xre  =586;
const int16 nota_xmib  =622;
const int16 nota_xmi  =658;
const int16 nota_xfa  =698;
const int16 nota_xsolb  =740;
const int16 nota_xsol  =784;
const int16 nota_xlab  =830;
const int16 nota_xla  =880;
const int16 nota_xsib  =932;
const int16 nota_xsi  =986;


//==============================================================================
//           rotinas de tons (oitava acima)
//==============================================================================

void n_xdo(int16 b){        //D
  int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_xdo-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);
       set_timer1(0xffff-(500000/nota_xdo-10));
      t1if=0;
       while(!t1if);

   }
}

void n_xreb(int16 b){         // 'RE BEMOL'
   int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_xreb-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);

      set_timer1(0xffff-(500000/nota_xreb-10));
      t1if=0;
       while(!t1if);
      }
}
void n_xre(int16 b){          // 'RE'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_xre-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);
       set_timer1(0xffff-(500000/nota_xre-10));
      t1if=0;
       while(!t1if);
      }
}
void n_xmib(int16 b){         // 'MI BEMOL'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_xmib-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);

set_timer1(0xffff-(500000/nota_xmib-10));
      t1if=0;
       while(!t1if);
      }
}
void n_xmi(int16 b){           // 'MI'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_xmi-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);
       set_timer1(0xffff-(500000/nota_xmi-10));
      t1if=0;
       while(!t1if);
      }
}
void n_xfa(int16 b){            // 'FA'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_xfa-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);
       set_timer1(0xffff-(500000/nota_xfa-10));
      t1if=0;
       while(!t1if);
      }
}
void n_xsolb(int16 b){            // 'SOL BEMOL'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);

      set_timer1(0xffff-(500000/nota_xsolb-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);

      set_timer1(0xffff-(500000/nota_xsolb-10));
      t1if=0;
       while(!t1if);
      }
}
void n_xsol(int16 b){             // 'SOL'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_xsol-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);

      set_timer1(0xffff-(500000/nota_xsol-10));
      t1if=0;
       while(!t1if);
      }
}
void n_xlab(int16 b){             //'LA BEMOL'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_xlab-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);

      set_timer1(0xffff-(500000/nota_xlab-10));
      t1if=0;
       while(!t1if);
      }
}
void n_xla(int16 b){           // 'LA'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_xla-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);
       set_timer1(0xffff-(500000/nota_xla-10));
      t1if=0;
       while(!t1if);
      }
}
void n_xsib(int16 b){          // 'SI BEMOL'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_xsib-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);

      set_timer1(0xffff-(500000/nota_xsib-10));
      t1if=0;
       while(!t1if);
      }
}
void n_xsi(int16 b){          // 'SI'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_xsi-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);
       set_timer1(0xffff-(500000/nota_xsi-10));
      t1if=0;
       while(!t1if);
      }
}
//==============================================================================
//           rotinas de tons
//==============================================================================
void n_do(int16 b){         //do
 int16 a;
     output_high(TONE_PIN);
     for(a=0;a<b;a++){
      set_timer1(0xffff-(500000/nota_do-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);
       set_timer1(0xffff-(500000/nota_do-10));
      t1if=0;
       while(!t1if);
    }
}


void n_reb(int16 b){         //'r bemol'
 int16 a;
    for(a=0;a<b;a++){

      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_reb-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);

set_timer1(0xffff-(500000/nota_reb-10));
      t1if=0;
       while(!t1if);
      }
}
void n_re(int16 b){          // 're'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_re-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);
       set_timer1(0xffff-(500000/nota_re-10));
      t1if=0;
       while(!t1if);
      }
}
void n_mib(int16 b){         // 'mi bemol'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_mib-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);

      set_timer1(0xffff-(500000/nota_mib-10));
      t1if=0;
       while(!t1if);
      }
}
void n_mi(int16 b){           // 'mi'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_mi-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);
       set_timer1(0xffff-(500000/nota_mi-10));
      t1if=0;
       while(!t1if);
      }
}
void n_fa(int16 b){            // 'f'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_fa-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);
       set_timer1(0xffff-(500000/nota_fa-10));
      t1if=0;
       while(!t1if);
      }
}
void n_solb(int16 b){            // 'sol bemol'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);

      set_timer1(0xffff-(500000/nota_solb-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);

      set_timer1(0xffff-(500000/nota_solb-10));
      t1if=0;
       while(!t1if);
      }
}
void n_sol(int16 b){             // 'sol'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_sol-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);

      set_timer1(0xffff-(500000/nota_sol-10));
      t1if=0;
       while(!t1if);
      }
}
void n_lab(int16 b){             //'l bemol'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_lab-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);

      set_timer1(0xffff-(500000/nota_lab-10));
      t1if=0;
       while(!t1if);
      }
}
void n_la(int16 b){           // 'l'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_la-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);
       set_timer1(0xffff-(500000/nota_la-10));
      t1if=0;
       while(!t1if);
      }
}
void n_sib(int16 b){          // 's bemol'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_sib-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);

      set_timer1(0xffff-(500000/nota_sib-10));
      t1if=0;
       while(!t1if);
      }
}
void n_si(int16 b){          // 's'
 int16 a;
    for(a=0;a<b;a++){
      output_high(TONE_PIN);
      set_timer1(0xffff-(500000/nota_si-10));
      t1if=0;
      while(!t1if);
      output_low(TONE_PIN);
       set_timer1(0xffff-(500000/nota_si-10));
      t1if=0;
       while(!t1if);
      }
}




void remifasol(){         //sequncia repetitiva (taram...taram...)
     n_mib(80);//re#
     n_mi(140);//mi
     n_solb(80);//fa#
     n_sol(140);//sol

 }

//==============================================================================
//        ROTINA PRINCIPAL
//==============================================================================


void main() {

   setup_adc_ports(ADC_OFF);//desliga conversor AD
   setup_counters(RTCC_INTERNAL,RTCC_DIV_1);
   setup_timer_1(T1_INTERNAL | T1_DIV_BY_1);
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);
   port_a_pullups(true);

//==============================================================================
//        LOOP PRINCIPAL
//==============================================================================
  while(1){   //SEGUE A MUSICA 'PANTERA COR DE ROSA' (reproduzir enquanto esti-
  //  ver com alimentao no PIC).
//Para os que entendem de msica ( no  meu caso), podero 'melhorar' a
//qualidade da msica


     remifasol();
     remifasol();

     n_xdo(120);//DO
     n_si(120);//si
     n_solb(120);//fa#
     n_sol(120);//sol
     n_si(120);//si
     n_sib(250);//sib

     n_la(120);
     n_sol(120);
     n_mi(120);
     n_re(120);
     n_mi(250);

     remifasol();
     remifasol();

     n_la(120);
     n_si(120);
     n_sol(120);
     n_si(120);
     n_xmi(120);
     n_xmib(650);
     delay_ms(200);  //sem som neste periodo

     remifasol();
     remifasol();

     n_xdo(120);
     n_si(120);
     n_mi(120);
     n_sol(120);
     n_si(120);
     n_sib(120);

     n_la(120);
     n_sol(120);
     n_mi(120);
     n_re(120);
     n_mi(250);

     n_mi(120);
     n_xmi(120);
     n_xre(120);
     n_si(120);
     n_la(120);
     n_sol(120);
     n_mi(120);

     n_si(120);
     n_la(120);
     n_si(120);
     n_la(120);
     n_si(120);
     n_la(120);
     n_si(120);
     n_la(120);

     n_sol(120);
     n_mi(120);
     n_re(120);
     n_mi(500);


     n_sol(120);
     n_mi(120);
     n_re(120);
     n_mi(500);


     n_sol(120);
     n_mi(120);
     n_re(120);
     n_mi(500);



  }

}
//==============================================================================
//                  fim do programa
//==============================================================================


